import arcgisscripting, sys, string, os, random, math
gp = arcgisscripting.create()
gp.OverwriteOutput = 1

try:
    gp.Workspace = r"Z:\Temp\PlanBlocksR5.mdb"            # workspace name
    fc = "PlanBlocksR5_v1prj"                                      # feature class name
    inDist = 500                                     # neighbor distance, unit: meter

    print "Starting.."
    cur = gp.UpdateCursor(fc)
    row = cur.Next()
    n = 0
    while row:
        n = n + 1
        if math.fmod(n,100)==0:
            print "  " + str(n)
        pID = int(row.Block_ID)
        expr = "Block_ID = " + str(pID)

        if row.neighbors == "":
            landLayer = "lyr"
            gp.MakeFeatureLayer_management(fc,landLayer)
            gp.SelectLayerByAttribute_management(landLayer, "NEW_SELECTION", expr)

            #Select neighbor parcel
            gp.SelectLayerByLocation_management(landLayer, "WITHIN_A_DISTANCE", \
                                                landLayer, str(inDist), "NEW_SELECTION")
            gp.SelectLayerByAttribute_management(landLayer, "REMOVE_FROM_SELECTION", expr)

            #Create search cursor in land layer and get value FID field
            pNlist = ""
            pNcount = 0
            ids = gp.SearchCursor(landLayer)
            id = ids.Next()
            while id:
                iPID = int(id.Block_ID)
                pNlist = str(iPID) + ";" + pNlist
                if len(pNlist)>100:
                    break
                pNcount = pNcount + 1
                id = ids.Next()
            del id, ids
            
            row.neighbors = pNlist
            cur.UpdateRow(row)
        row = cur.Next()
    del row, cur

    del gp
    print "finish"
except:
    gp.GetMessages()
